<template>
  <div id="board">
    <div id="heading">
      <Top></Top>
    </div>
    <div id="wrapper">
      <div id="content" data-layout-type="masonry">
        <template v-if="$mq == 'sm'">
          <popular-tags class="item" />
          <card
            class="item"
            v-for="post in posts"
            :key="post.id"
            :post="post"
            size="little"
            v-masonry-tile
          ></card>
        </template>
        <div
          v-else
          class="masonry"
          v-masonry
          transition-duration="0s"
          item-selector=".item"
          fit-width="true"
        >
          <popular-tags class="item" />
          <card
            class="item"
            v-for="post in posts"
            :key="post.id"
            :post="post"
            size="little"
            v-masonry-tile
          ></card>
        </div>
        <intersector @intersect="load_more" />
        <h3 v-if="loading_more">
          <p>Cargando mas...</p>
        </h3>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

import EventBus from "@/lib/event_bus";
import Card from "@/components/Card/_Card";
import Top from "@/components/Top";
import Intersector from "@/components/Intersector";
import PopularTags from "@/components/Tag/Popular";

export default {
  name: "Discover",
  components: {
    Top,
    Card,
    Intersector,
    PopularTags
  },
  data: () => ({
    loading_posts: false,
    loading_more: false,
    posts: [],
    next: null,
    last_page: false
  }),
  computed: {},
  methods: {
    async fetch_public() {
      this.loading_posts = true;
      const { data: res } = await axios.get(`/api/v1/feed/public`);
      this.posts = res.items;
      this.last_page = res.last_page;
      this.next = res.next;
      this.loading_posts = false;
    },
    async load_more() {
      if (this.loading_posts || this.loading_more || this.last_page) return;
      this.loading_more = true;
      const { data: res } = await axios.get(`/api/v1/feed/public`, {
        params: { before: this.next }
      });
      const body = document.getElementsByTagName("html")[0];
      const old_scroll = body.scrollTop;

      this.posts.push(...res.items);
      this.last_page = res.last_page;
      this.next = res.next;

      this.$nextTick(() => {
        body.scrollTop = old_scroll;
      });
      this.loading_more = false;
    },
    redraw_masonry() {
      this.$redrawVueMasonry("#masonry");
    },
  },
  mounted() {
    this.fetch_public();
    EventBus.$on("medialoaded", e => {
      this.redraw_masonry()
    });
  },
  beforeDestroy() {
    this.$store.dispatch("cleanFeedPosts");
  }
};
</script>

<style lang="scss" scoped>
#wrapper {
  padding: 30px 0;
}
#content {
  justify-content: flex-start;
  align-items: center;
}
.hot-tags {
  width: 325px;
  margin: 0 15px 30px 15px;
}
</style>
